//---------------------------------------------------------------------------

#ifndef Unit2H
#define Unit2H
#include "System.hpp"
#include "Classes.hpp"
#include "Stdctrls.hpp"
#include <typeinfo>
//---------------------------------------------------------------------------
class Employee {

	static unsigned int count;
	static unsigned int uid;

	public:
	Employee() {
		++count;
		id = ++uid;
	}
	virtual ~Employee() {
		--count;
	}
	AnsiString name;
	unsigned int id;

	static unsigned int getCount() { return count; }

};

class Manager : public Employee {

};

class Scientist : public Employee {

};

class Laborer : public Employee {

};

class Professor : public Scientist {

};

class Student : public Scientist {

};

class Researcher : public Scientist {

};

class EmployeeList : public TList {

	TListBox & out;
	unsigned int classId;

	public:
	EmployeeList( TListBox & out ):out(out),classId(0) {}

	void Add( Employee * e ) {
		TList::Add( e );
		if (isVisible( e ))
			out.Items->Add(e->name);
	}

	void Delete( Employee * e ) {
		int p = IndexOf( e );
		if (p<0) return;
		TList::Delete(p);
		redraw();
	}

	void setFilter( unsigned int classId ) {
		this->classId = classId;
		redraw();
	}

	private:
	void redraw() {
		out.Clear();
		for (int i=0;i<Count;i++) {
			Employee * e = (Employee*)Items[i];
			if (isVisible( e ))
				out.Items->Add( e->name );
		}
	}

	bool isVisible( Employee * e ) {

		if (classId == 0) return true;

		if (classId == 1)
			return dynamic_cast<Manager *>(e) != 0;
		if (classId == 2)
			return dynamic_cast<Scientist *>(e) != 0;
		if (classId == 3)
			return dynamic_cast<Laborer *>(e) != 0;
		if (classId == 4)
			return dynamic_cast<Professor *>(e) != 0;
		if (classId == 5)
			return dynamic_cast<Student *>(e) != 0;
		if (classId == 6)
			return dynamic_cast<Researcher *>(e) != 0;

		return false;
	}

};

#endif
 